731ca6f28dbc41d00cde3d8fd18fa9599284bb55
[oota-llvm.git] / utils / buildit / build_llvm
1 #!/bin/sh
2 # LLVM LOCAL file B&I
3
4 set -x
5
6 # Build LLVM the "Apple way".
7 # Parameters:
8
9 # The first parameter is a space-separated list of the architectures the
10 # compilers will run on. For instance, "ppc i386". If the current machine
11 # isn't in the list, it will (effectively) be added.
12 HOSTS="$1"
13
14 # The second parameter is a space-separated list of the architectures the
15 # compilers will generate code for. If the current machine isn't in the list, a
16 # compiler for it will get built anyway, but won't be installed.
17 # FIXME: The list of targets is currently hard-coded and TARGETS is not used.
18 TARGETS="$2"
19
20 # The third parameter is the path to the compiler sources. There should be a
21 # shell script named 'configure' in this directory. This script makes a copy...
22 ORIG_SRC_DIR="$3"
23
24 # The fourth parameter is the location where the LLVM will be installed. You can
25 # move it once it's built, so this mostly controls the layout of $DEST_DIR.
26 DEST_ROOT="$4"
27
28 # The fifth parameter is the place where the compiler will be copied once it's
29 # built.
30 DEST_DIR="$5"
31
32 # The sixth parameter is a directory in which to place information (like
33 # unstripped executables and generated source files) helpful in debugging the
34 # resulting compiler.
35 SYM_DIR="$6"
36
37 # The seventh parameter is a yes/no that indicates whether assertions should be
38 # enabled in the LLVM libs/tools.
39 LLVM_ASSERTIONS="$7"
40
41 # The eighth parameter is a yes/no that indicates whether this is an optimized
42 # build.
43 LLVM_OPTIMIZED="$8"
44
45 # The ninth parameter is a yes/no that indicates whether libLTO.dylib
46 # should be installed.
47 INSTALL_LIBLTO="$9"
48
49 # A yes/no parameter that controls whether to cross-build for an ARM host.
50 ARM_HOSTED_BUILD="${10}"
51
52 # A yes/no parameter that controls whether to cross-build for the iOS simulator
53 IOS_SIM_BUILD="${11}"
54
55 # The version number of the submission, e.g. 1007.
56 LLVM_SUBMIT_VERSION="${12}"
57
58 # The subversion number of the submission, e.g. 03.
59 LLVM_SUBMIT_SUBVERSION="${13}"
60
61 # The current working directory is where the build will happen. It may already
62 # contain a partial result of an interrupted build, in which case this script
63 # will continue where it left off.
64 DIR=`pwd`
65
66 DARWIN_VERS=`uname -r | sed 's/\..*//'`
67 echo DARWIN_VERS = $DARWIN_VERS
68
69 ################################################################################
70 # Run the build.
71
72 # Create the source tree we'll actually use to build, deleting
73 # tcl since it doesn't actually build properly in a cross environment
74 # and we don't really need it.
75 SRC_DIR=$DIR/src
76 rm -rf $SRC_DIR || exit 1
77 mkdir $SRC_DIR || exit 1
78 ln -s $ORIG_SRC_DIR/* $SRC_DIR/ || exit 1
79 # We can't use the top-level Makefile as-is.  Remove the soft link:
80 rm $SRC_DIR/Makefile || exit 1
81 # Now create our own by editing the top-level Makefile, deleting every line marked "Apple-style":
82 sed -e '/[Aa]pple-style/d' -e '/include.*GNUmakefile/d' $ORIG_SRC_DIR/Makefile > $SRC_DIR/Makefile || exit 1
83
84 # Build the LLVM tree universal.
85 mkdir -p $DIR/obj-llvm || exit 1
86 cd $DIR/obj-llvm || exit 1
87
88 if [ "$ARM_HOSTED_BUILD" = yes ]; then
89   # The cross-tools' build process expects to find an existing cross toolchain
90   # under names like 'arm-apple-darwin$DARWIN_VERS-as'; so make them.
91   rm -rf $DIR/bin || exit 1
92   mkdir $DIR/bin || exit 1
93   for prog in ar nm ranlib strip lipo ld as ; do
94     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
95     T=`xcrun -sdk $SDKROOT -find ${prog}`
96     echo '#!/bin/sh' > $P || exit 1
97     echo 'exec '$T' "$@"' >> $P || exit 1
98     chmod a+x $P || exit 1
99   done
100   # Try to use the platform llvm-gcc. Fall back to gcc if it's not available.
101   for prog in gcc g++ ; do
102     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
103     T=`xcrun -sdk $SDKROOT -find llvm-${prog}`
104     if [ "x$T" = "x" ] ; then
105       T=`xcrun -sdk $SDKROOT -find ${prog}`
106     fi
107     echo '#!/bin/sh' > $P || exit 1
108     echo 'exec '$T' -arch armv7 -isysroot '${SDKROOT}' "$@"' >> $P || exit 1
109     chmod a+x $P || exit 1
110   done
111
112   PATH=$DIR/bin:$PATH
113 fi
114
115 if [ "$ARM_HOSTED_BUILD" = yes ]; then
116   configure_opts="--enable-targets=arm --host=arm-apple-darwin10 \
117                   --target=arm-apple-darwin10 --build=i686-apple-darwin10"
118 elif [ "$IOS_SIM_BUILD" = yes ]; then
119   # Use a non-standard "darwin_sim" host triple to trigger a cross-build.
120   configure_opts="--enable-targets=x86 --host=i686-apple-darwin_sim \
121                   --build=i686-apple-darwin10"
122 else
123   configure_opts="--enable-targets=arm,x86,cbe"
124 fi
125
126 if [ \! -f Makefile.config ]; then
127   $SRC_DIR/configure --prefix=$DEST_DIR$DEST_ROOT $configure_opts \
128     --enable-assertions=$LLVM_ASSERTIONS \
129     --enable-optimized=$LLVM_OPTIMIZED \
130     --disable-bindings \
131     || exit 1
132 fi
133
134 SUBVERSION=`echo $RC_ProjectSourceVersion | sed -e 's/[^.]*\.\([0-9]*\).*/\1/'`
135
136 if [ "x$SUBVERSION" != "x$RC_ProjectSourceVersion" ]; then
137     LLVM_SUBMIT_SUBVERSION=`printf "%02d" $SUBVERSION`
138     RC_ProjectSourceVersion=`echo $RC_ProjectSourceVersion | sed -e 's/\..*//'`
139     LLVM_SUBMIT_VERSION=$RC_ProjectSourceVersion
140 fi
141
142 if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
143     LLVM_VERSION="$LLVM_SUBMIT_VERSION"
144 else
145     LLVM_VERSION="$LLVM_SUBMIT_VERSION-$LLVM_SUBMIT_SUBVERSION"
146 fi
147
148 GCC_VER=`cc --version 2>/dev/null | sed 1q`
149
150 if echo "$GCC_VER" | grep GCC > /dev/null; then
151     GCC_VER=`echo $GCC_VER | sed -e 's/.*(GCC) \([0-9.][0-9.]*\).*/\1/'`
152     MAJ_VER=`echo $GCC_VER | sed 's/\..*//'`
153     MIN_VER=`echo $GCC_VER | sed 's/[^.]*\.\([0-9]*\).*/\1/'`
154 fi
155
156 JOBS_FLAG=""
157
158 # Note: If compiling with GCC 4.0, don't pass the -jN flag. Building universal
159 # already has parallelism and we don't want to make the builders hit swap by
160 # firing off too many gccs at the same time.
161 if [ "x$MAJ_VER" != "x4" -o "x$MIN_VER" != "x0" ]; then
162     # Figure out how many make processes to run.
163     SYSCTL=`sysctl -n hw.activecpu`
164
165     # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot.
166     # Builders can default to 2, since even if they are single processor,
167     # nothing else is running on the machine.
168     if [ -z "$SYSCTL" ]; then
169         SYSCTL=2
170     fi
171
172     JOBS_FLAG="-j $SYSCTL"
173 fi
174
175 make $JOBS_FLAG $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$HOSTS" \
176     UNIVERSAL_SDK_PATH=$SDKROOT \
177     NO_RUNTIME_LIBS=1 \
178     DISABLE_EDIS=1 \
179     DEBUG_SYMBOLS=1 \
180     LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
181     LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
182     CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'" \
183     VERBOSE=1
184
185 if [ $? != 0 ] ; then
186     echo "error: LLVM 'make' failed!"
187     exit 1
188 fi 
189
190 ################################################################################
191 # Construct the actual destination root, by copying stuff from $DIR/dst-* to
192 # $DEST_DIR, with occasional 'lipo' commands.
193
194 cd $DEST_DIR || exit 1
195
196 # Clean out DEST_DIR in case -noclean was passed to buildit.
197 rm -rf * || exit 1
198
199 cd $DIR/obj-llvm || exit 1
200
201 # Install the tree into the destination directory.
202 make $LOCAL_MAKEFLAGS $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$HOSTS" \
203     NO_RUNTIME_LIBS=1 \
204     DISABLE_EDIS=1 \
205     DEBUG_SYMBOLS=1 \
206     LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
207     LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
208     OPTIMIZE_OPTION='-O3' VERBOSE=1 install
209
210 if ! test $? == 0 ; then
211     echo "error: LLVM 'make install' failed!"
212     exit 1
213 fi 
214
215 # Install Version.h
216 LLVM_MINOR_VERSION=`echo $LLVM_SUBMIT_SUBVERSION | sed -e 's,0*\([1-9][0-9]*\),\1,'`
217 if [ "x$LLVM_MINOR_VERSION" = "x" ]; then
218     LLVM_MINOR_VERSION=0
219 fi
220 RC_ProjectSourceSubversion=`printf "%d" $LLVM_MINOR_VERSION`
221 echo "#define LLVM_VERSION ${RC_ProjectSourceVersion}" > $DEST_DIR$DEST_ROOT/include/llvm/Version.h
222 echo "#define LLVM_MINOR_VERSION ${RC_ProjectSourceSubversion}" >> $DEST_DIR$DEST_ROOT/include/llvm/Version.h
223
224 if [ "x$LLVM_DEBUG" != "x1" ]; then
225     # Strip local symbols from llvm libraries.
226     #
227     # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
228     # PPC objects!
229     strip -Sl $DEST_DIR$DEST_ROOT/lib/*.[oa]
230     for f in `ls $DEST_DIR$DEST_ROOT/lib/*.so`; do
231         strip -Sxl $f
232     done
233 fi
234
235 # Copy over the tblgen utility.
236 cp `find $DIR -name tblgen` $DEST_DIR$DEST_ROOT/bin
237
238 # Remove .dir files 
239 cd $DEST_DIR$DEST_ROOT
240 rm -f bin/.dir etc/llvm/.dir lib/.dir
241
242 # Remove PPC64 fat slices.
243 cd $DEST_DIR$DEST_ROOT/bin
244 if [ $MACOSX_DEPLOYMENT_TARGET = "10.4" ]; then
245     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
246         -exec lipo -extract ppc -extract i386 {} -output {} \;
247 elif [ $MACOSX_DEPLOYMENT_TARGET = "10.5" ]; then
248     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
249         -exec lipo -extract ppc7400 -extract i386 {} -output {} \;
250 else
251     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
252         -exec lipo -extract i386 -extract x86_64 {} -output {} \;
253 fi
254
255 # The Hello dylib is an example of how to build a pass.
256 # The BugpointPasses module is only used to test bugpoint.
257 # These unversioned dylibs cause verification failures, so do not install them.
258 # (The wildcards are used to match a "lib" prefix if it is present.)
259 rm $DEST_DIR$DEST_ROOT/lib/*LLVMHello.dylib
260 rm $DEST_DIR$DEST_ROOT/lib/*BugpointPasses.dylib
261
262 # Compress manpages
263 MDIR=$DEST_DIR$DEST_ROOT/share/man/man1
264 gzip -f $MDIR/*
265
266 ################################################################################
267 # Create SYM_DIR with information required for debugging.
268
269 # Figure out how many make processes to run.
270 SYSCTL=`sysctl -n hw.activecpu`
271
272 # hw.activecpu only available in 10.2.6 and later
273 if [ -z "$SYSCTL" ]; then
274   SYSCTL=`sysctl -n hw.ncpu`
275 fi
276
277 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot. Builders
278 # can default to 2, since even if they are single processor, nothing else is
279 # running on the machine.
280 if [ -z "$SYSCTL" ]; then
281   SYSCTL=2
282 fi
283
284 cd $SYM_DIR || exit 1
285
286 # Clean out SYM_DIR in case -noclean was passed to buildit.
287 rm -rf * || exit 1
288
289 # Generate .dSYM files
290 find $DEST_DIR -perm -0111 -type f \
291     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config -o -name '*.a' \) \
292     -print | xargs -n 1 -P ${SYSCTL} dsymutil
293
294 # Save .dSYM files and .a archives
295 cd $DEST_DIR || exit 1
296 find . \( -path \*.dSYM/\* -or -name \*.a \) -print \
297     | cpio -pdml $SYM_DIR || exit 1
298
299 # Save source files.
300 mkdir $SYM_DIR/src || exit 1
301 cd $DIR || exit 1
302 find obj-* -name \*.\[chy\] -o -name \*.cpp -print \
303     | cpio -pdml $SYM_DIR/src || exit 1
304
305 ################################################################################
306 # Install and strip libLTO.dylib
307
308 cd $DEST_DIR$DEST_ROOT
309 if [ "$INSTALL_LIBLTO" = "yes" ]; then
310   DT_HOME="$DEST_DIR/Developer/usr"
311   mkdir -p $DT_HOME/lib
312   mv lib/libLTO.dylib $DT_HOME/lib/libLTO.dylib
313
314   # Save a copy of the unstripped dylib
315   mkdir -p $SYM_DIR/Developer/usr/lib
316   cp $DT_HOME/lib/libLTO.dylib $SYM_DIR/Developer/usr/lib/libLTO.dylib
317
318   # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
319   # PPC objects!
320   strip -arch all -Sl $DT_HOME/lib/libLTO.dylib
321
322   if [ "x$DISABLE_USR_LINKS" == "x" ]; then
323     # Add a symlink in /usr/lib for B&I.
324     mkdir -p $DEST_DIR/usr/lib/
325     (cd $DEST_DIR/usr/lib && \
326       ln -s ../../Developer/usr/lib/libLTO.dylib ./libLTO.dylib)
327   fi
328 else
329   rm -f lib/libLTO.dylib
330 fi
331 rm -f lib/libLTO.a lib/libLTO.la
332
333 # Omit lto.h from the result.  Clang will supply.
334 find $DEST_DIR$DEST_ROOT -name lto.h -delete
335
336 ################################################################################
337 # Remove debugging information from DEST_DIR.
338
339 cd $DIR || exit 1
340
341 find $DEST_DIR -name \*.a -print | xargs ranlib || exit 1
342 find $DEST_DIR -name \*.dSYM -print | xargs rm -r || exit 1
343
344 # Strip debugging information from files
345 #
346 # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
347 # PPC objects!
348 find $DEST_DIR -perm -0111 -type f \
349     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config \) \
350     -print | xargs -n 1 -P ${SYSCTL} strip -arch all -Sl
351
352 chgrp -h -R wheel $DEST_DIR
353 chgrp -R wheel $DEST_DIR
354
355 ################################################################################
356 # Remove the docs directory
357
358 rm -rf $DEST_DIR$DEST_ROOT/docs
359
360 ################################################################################
361 # w00t! Done!
362
363 exit 0